﻿#include "CClient.h"

#include <iostream>

////////////////////////////////////////////////////////////////////////////////
// constructor
////////////////////////////////////////////////////////////////////////////////
CClient::CClient()
{
}

////////////////////////////////////////////////////////////////////////////////
// destructor
////////////////////////////////////////////////////////////////////////////////
CClient::~CClient()
{
}

////////////////////////////////////////////////////////////////////////////////
// initialize
////////////////////////////////////////////////////////////////////////////////
bool CClient::initialize()
{
	m_UI.setModel(&m_Model);
	m_UI.initialize();
	m_Model.initialize();
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// mail loop
////////////////////////////////////////////////////////////////////////////////
void CClient::mainloop()
{
	// とりあえず無限ループに入る

	m_UI.start();

	while(true){
		if(m_UI.existEvent()){
			ClientInputEvent a_Event = m_UI.getEvent();
			if(a_Event == "CONNECT"){
				m_Model.addEvent("CONNECT");
			}
			else if(a_Event == "DISCONNECT"){
				m_Model.addEvent("DISCONNECT");
			}
			else if(a_Event == "LOGIN"){
				m_Model.addEvent("LOGIN");
			}
			else if(a_Event == "LOGOUT"){
				m_Model.addEvent("LOGOUT");
			}
			else if(a_Event == "POSITION"){
				m_Model.addEvent("POSITION");
			}
			else if(a_Event == "FRONT"){
				m_Model.addEvent("FRONT");
			}
			else if(a_Event == "BACK"){
				m_Model.addEvent("BACK");
			}
			else if(a_Event == "TURN_RIGHT"){
				m_Model.addEvent("TURN_RIGHT");
			}
			else if(a_Event == "TURN_LEFT"){
				m_Model.addEvent("TURN_LEFT");
			}
			else if(a_Event == "END"){
				break;
			}
		}
		m_Model.process();
		Sleep(1);
	}
}
