﻿#include "CServer.h"

#include <iostream>

////////////////////////////////////////////////////////////////////////////////
// constructor
////////////////////////////////////////////////////////////////////////////////
CServer::CServer()
{
}

////////////////////////////////////////////////////////////////////////////////
// destructor
////////////////////////////////////////////////////////////////////////////////
CServer::~CServer()
{
}

////////////////////////////////////////////////////////////////////////////////
// initialize
////////////////////////////////////////////////////////////////////////////////
bool CServer::initialize()
{
	m_Input.initialize();
	m_Model.initialize();
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// mail loop
////////////////////////////////////////////////////////////////////////////////
void CServer::mainloop()
{
	// とりあえず無限ループに入る
	// qの入力で終了


	std::cout << "start server" << std::endl;
	std::cout << "input \"END\" to end" << std::endl;

	while(true){
		if(m_Input.existEvent()){
			ServerInputEvent a_Event = m_Input.getEvent();
			if(a_Event == "END"){
				break;
			}
		}
		m_Model.process();
		Sleep(1);
	}


	std::cout << "end server" << std::endl;
}
